// Re-write using "auto" for iterators
// Re-write using range-based for "for (auto &x : mapv)..."

#include <map>
#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdlib>
using namespace std;

bool compare(pair<string,char> a, pair<string,char> b) {
  return a.second < b.second;
}

int main() {
  
  map<string, char> grades;

  grades["chris"] = 'C';
  grades["sally"] = 'A';
  grades["bob"] = 'B';
  grades["eric"] = 'C';
  grades["sam"] = 'A';


  for ( map<string, char>::const_iterator itr = grades.begin();
	itr != grades.end(); itr++ )
    cout << itr->first << " " << itr->second << endl;

  // exit(0);  // ***
  
  cout << endl << "Sorted by grade..." << endl;

  vector<pair<string, char> > mapv;
  
  for ( map<string, char>::iterator itr = grades.begin();
       itr != grades.end(); itr++ )
    mapv.push_back(*itr);

  sort( mapv.begin(), mapv.end(), compare );

  for ( vector<pair<string,char> >::const_iterator itr = mapv.begin();
	itr != mapv.end(); itr++ )
	cout << itr->first << " " << itr->second << endl;
}
