#include <vector>
#include <iostream>
using namespace std;

int main() {

  // using initializer lists with vector<int>
  vector<int> intv = {2, 3, 5, 7, 11};


  // using "auto" for iterator type
  // vector<int>::iterator itrv...
  //
  //   for ( auto itr = intv.begin(); itr != intv.end(); itr++ )
  //     *itr = (*itr) * (*itr);

  // range-based for
  for ( auto &x : intv )
    x = x*x;

  // using range-based for loop
  for ( auto &x : intv )
    cout << x << " ";
  cout << endl;

  // reverse range-based for requires additional code
  for ( auto itr = intv.end(); itr != intv.begin(); )
    cout << *(--itr) << " ";
  cout << endl;


}
